package com.izouma.nineth.web;
import com.izouma.nineth.domain.CommissionRecord;
import com.izouma.nineth.service.CommissionRecordService;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.CommissionRecordRepo;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/commissionRecord")
@AllArgsConstructor
public class CommissionRecordController extends BaseController {
    private CommissionRecordService commissionRecordService;
    private CommissionRecordRepo commissionRecordRepo;

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public CommissionRecord save(@RequestBody CommissionRecord record) {
        if (record.getId() != null) {
            CommissionRecord orig = commissionRecordRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return commissionRecordRepo.save(orig);
        }
        return commissionRecordRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<CommissionRecord> all(@RequestBody PageQuery pageQuery) {
        return commissionRecordService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public CommissionRecord get(@PathVariable Long id) {
        return commissionRecordRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        commissionRecordRepo.softDelete(id);
    }

    @PostMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<CommissionRecord> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

